import greenfoot.*; 
import java.awt.Color;
/**
 * @author (Sugeng Rianto and Ubaidillah) 
 * @version (1.0)
 */
public class BtnPutar  extends Actor
{
    public int min=0,max=360,ID=0;
    public int mrotate=0,step=1,awal=90;
    public int rotasi=awal,penamhah=0;
    public boolean drag=false;
    public Latar latar=null;
    public double Value=0;
    
    public void dragEnd(){};
    
    private double setTimeValue()
    {
        double nilai=0;
        switch(getRotation()){
            case 135: nilai=200000; break;
            case 150: nilai=100000; break;
            case 165: nilai=50000; break;
            case 180: nilai=20000; break;
            case 195: nilai=10000; break;
            case 210: nilai=5000; break;
            case 225: nilai=2000; break;
            case 240: nilai=1000; break;
            case 255: nilai=500; break;
            case 270: nilai=200; break;
            case 285: nilai=100; break;
            case 300: nilai=50; break;
            case 315: nilai=20; break;
            case 330: nilai=10; break;
            case 345: nilai=5; break;
            case 0: nilai=2; break;
            case 15: nilai=1; break;
            case 30: nilai=0.5; break;
        }        
        return nilai;
    }
    
    private double setVoltValue()
    {
        double nilai=0;
        switch(getRotation()){
            case 105: nilai=20; break;
            case 135: nilai=10; break;
            case 165: nilai=5; break;
            case 195: nilai=2; break;
            case 225: nilai=1; break;
            case 255: nilai=0.5; break;
            case 285: nilai=0.2; break;
            case 315: nilai=0.1; break;
            case 345: nilai=0.05; break;
            case 15: nilai=0.02; break;
            case 45: nilai=0.01; break;
            case 75: nilai=0.005; break;
        }        
        return nilai;
    }
    
    public void setValue()
    {
        if(ID==0)Value=setTimeValue();
        else Value=setVoltValue();
    }
    
    public void setGambar()
    {
        int w=150,h=w;
        GreenfootImage image=new GreenfootImage(w,h);
        image.setColor(new Color(0,186,255));
        GreenfootImage recto=new GreenfootImage(w,30);
        recto.setColor(new Color(0,186,255));
        recto.drawRect(0,0,recto.getWidth()-1,recto.getHeight()-1);
        image.drawImage(recto,0,(int)(0.5*(image.getHeight()-recto.getHeight())));
        recto=new GreenfootImage(30,h);
        recto.setColor(new Color(0,186,255));
        recto.drawRect(0,0,recto.getWidth()-1,recto.getHeight()-1);
        image.drawImage(recto,(int)(0.5*(image.getWidth()-recto.getWidth())),0);
        GreenfootImage oval=new GreenfootImage((int)(0.85*w),(int)(0.85*w));
        oval.fillOval(0,0,oval.getWidth()-1,oval.getHeight()-1);
        oval.setColor(new Color(0,186,255));
        oval.drawOval(0,0,oval.getWidth()-1,oval.getHeight()-1);
        oval.drawOval(1,1,oval.getWidth()-3,oval.getHeight()-3);
        image.drawImage(oval,(int)(0.5*(image.getWidth()-oval.getWidth())),(int)(0.5*(image.getHeight()-oval.getHeight())));
        oval.scale((int)(0.75*oval.getWidth()),(int)(0.75*oval.getHeight()));
        image.drawImage(oval,(int)(0.5*(image.getWidth()-oval.getWidth())),(int)(0.5*(image.getHeight()-oval.getHeight())));
        GreenfootImage tiga=new GreenfootImage((int)(0.1*w),(int)(0.1*w));
        int[] x=new int[]{0,tiga.getWidth()-1,0};
        int[] y=new int[]{0,(int)(0.5*tiga.getHeight()),tiga.getHeight()-1};
        tiga.setColor(new Color(0,186,255));
        tiga.fillPolygon(x,y,3);
        image.drawImage(tiga,(int)(0.75*image.getWidth()-0.5*tiga.getWidth()),(int)(0.5*(image.getHeight()-tiga.getHeight())));
        setImage(image);
    }
    
    public void addScale()
    {
        int r=90;
        int[] sudut=new int[]{135,150,165,180,195,210,225,240,255,270,285,300,315,330,345,0,15,30};
        String[] kata=new String[]{"0.2","0.1","50","20","10","5","2","1","0.5","0.2","0.1","50","20","10","5","2","1","0.5"};
        
        if(ID==1){            
            sudut=new int[]{105,135,165,195,225,255,285,315,345,15,45,75};
            kata=new String[]{"20","10","5","2","1","0.5","0.2","0.1","50","20","10","5"};
        }
        
        Latar latar=(Latar)getWorld();
        for(int i=0;i<sudut.length;i++){
            int posx=(int)(getX()+r*Math.cos(sudut[i]*Math.PI/180));
            int posy=(int)(getY()+r*Math.sin(sudut[i]*Math.PI/180));
            latar.addObject(new Tulisan(kata[i]),posx,posy);
        }
    }
    
    public void addedToWorld(World Latar)
    {        
        setGambar();
        addScale();
        
        latar=(Latar)getWorld();
        setRotation(awal);
        mrotate=min;
        rotasi=awal;
        setValue();
    }
    
    public void act() 
    {
        if(Greenfoot.mouseDragged(this)){ 
            boolean pass=true;
            MouseInfo mouse=Greenfoot.getMouseInfo();
            int arahx=mouse.getX();
            int arahy=mouse.getY();
            int rotate=(int)(Math.atan2(arahy-getY(),arahx-getX())*180/Math.PI); 
            int rotateo=getRotation();
            int mrotateo=mrotate;
            int dx=0,a=0;
            
            if(rotateo>=0 && rotateo<=90){
                if(rotate>-180 && rotateo<-90)pass=false;
            }
            
            if(rotateo>270 && rotateo<360){
                rotateo=-1*(360-rotateo);
                if(rotate<=180 && rotateo>90)pass=false;
            }
            
            if(rotateo>90 && rotateo<=180){
                if(rotate<0)rotate=180+Math.abs(-180-rotate);
                if(rotate<0&& rotateo>=-90)pass=false;
            }
            
            if(rotateo>180 && rotateo<=270){
                if(rotate<0)rotate=180+Math.abs(-180-rotate);
                if(rotate>=0 && rotate<=90)pass=false;
            }
            
            if(pass)dx=rotate-rotateo;
            
            if(Math.abs(dx)>50)pass=false;
            if(Math.abs(dx)<step)pass=false;
            
            if(pass){
                int delta=Math.abs(dx)-(Math.abs(dx)%step);
                if(dx<0)delta*=-1;
                mrotate=mrotateo+delta;
                rotasi=rotateo+delta;
                if((mrotate<min)||(mrotate>max)){
                    mrotate=mrotateo;
                    rotasi=rotateo;
                }                
                setRotation(rotasi);
                drag=true;
            }
        }
        
        if(drag){
            latar.n=0;
            setValue();
        }
        
        if(Greenfoot.mouseDragEnded(this)){
            drag=false;
            dragEnd();
        }
    }     
}
