import greenfoot.*;  
import java.awt.Color;
/**
 * @author (Sugeng Rianto and Ubaidillah) 
 * @version (1.0)
 */
public class Layar extends Actor
{
    private void reset()
    {    
        int w=160,h=130;
        GreenfootImage image=new GreenfootImage(w,h);
        image.setColor(new Color(0,186,255));
        image.drawRect(0,0,w-1,h-1);
        setImage(image);
    }
    
    public void addedToWorld(World Latar) 
    {
        reset();
    }    
    
    public GreenfootImage drawSinus(double A,double f,int wo,int ho,double scalex,double scaley)
    {
        int w=1+wo,h=1+ho;
        GreenfootImage image=new GreenfootImage(w,h);
        ho=(int)(0.5*h);
        int yo=0;        
        image.setColor(new Color(0,186,255));
        double tambahan=0.01*Greenfoot.getRandomNumber(5);
        for(int i=0;i<image.getWidth();i++){
            double fo=f/scalex;
            if(fo>0.35)fo=0.35+tambahan;
            int y=(int)(-(A*scaley)*Math.sin(2*Math.PI*(1.0*i*fo)));
            y+=ho;
            if(i>0)image.drawLine(i-1,yo,i,y);
            yo=y;
        }
        return image;
    }
    
    public void drawSignal(double A,double f,double timediv,double voltdiv)
    {
        reset();
        timediv/=1000000;
        GreenfootImage layaro=getImage();
        double scalex=(1.0*layaro.getWidth()/(10*timediv));
        double scaley=(1.0*layaro.getHeight()/(8*voltdiv));
        int w=layaro.getWidth();
        int h=(int)(2*Math.abs(A)*scaley);
        
        if(w<0)w=1;if(h<0)h=1;
        if(w>layaro.getWidth())w=layaro.getWidth();
        if(h>layaro.getHeight())h=layaro.getHeight();
        
        GreenfootImage signal=drawSinus(A,f,w,h,scalex,scaley);
        
        layaro.drawImage(signal,0,(int)(0.5*(layaro.getHeight()-h)));
        setImage(layaro); 
    }
}
