import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * @author (Sugeng Rianto and Ubaidillah) 
 * @version (1.0)
 */
public class BtnGen extends BtnPutar
{
    private double setSatuan()
    {
        double nilai=0;
        nilai=0.1+(0.9*(mrotate-min)/(max-min));      
        return nilai;
    }
    
    private double setPuluhan()
    {
        double nilai=0;
        switch(getRotation()){
            case 150: nilai=1.0; break;
            case 180: nilai=10.0; break;
            case 210: nilai=100.0; break;
            case 240: nilai=1000.0; break;
            case 270: nilai=10000.0; break;
            case 300: nilai=100000.0; break;
        }        
        return nilai;
    }    

    public void setValue()
    {
        if(ID==2)Value=setSatuan();
        if(ID==3)Value=setPuluhan();
    }
    
    public void setGambar()
    {
        int w=100,h=w;
        GreenfootImage image=new GreenfootImage(w,w); 
        GreenfootImage oval=new GreenfootImage(w,w);
        oval.fillOval(0,0,oval.getWidth()-1,oval.getHeight()-1);
        oval.setColor(new Color(0,186,255));
        oval.drawOval(0,0,oval.getWidth()-1,oval.getHeight()-1);
        oval.drawOval(1,1,oval.getWidth()-3,oval.getHeight()-3);
        image.drawImage(oval,(int)(0.5*(image.getWidth()-oval.getWidth())),(int)(0.5*(image.getHeight()-oval.getHeight())));
        oval.scale((int)(0.75*oval.getWidth()),(int)(0.75*oval.getHeight()));
        image.drawImage(oval,(int)(0.5*(image.getWidth()-oval.getWidth())),(int)(0.5*(image.getHeight()-oval.getHeight())));
        GreenfootImage tiga=new GreenfootImage((int)(0.1*w),(int)(0.1*w));
        int[] x=new int[]{0,tiga.getWidth()-1,0};
        int[] y=new int[]{0,(int)(0.5*tiga.getHeight()),tiga.getHeight()-1};
        tiga.setColor(new Color(0,186,255));
        tiga.fillPolygon(x,y,3);
        image.drawImage(tiga,(int)(0.80*image.getWidth()-0.5*tiga.getWidth()),(int)(0.5*(image.getHeight()-tiga.getHeight())));
        setImage(image);
    }
    
    public void addScale()
    {
        int r=65;
        int[] sudut=new int[]{120,150,180,210,240,270,300};
        String[] kata=new String[]{"y","0","1","2","3","4","5"};
        
        if(ID==2){            
            sudut=new int[]{105,120,150,180,210,240,270,300,330,360,30};
            kata=new String[]{"x","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1.0"};
        }
        
        Latar latar=(Latar)getWorld();
        for(int i=0;i<sudut.length;i++){
            int posx=(int)(getX()+r*Math.cos(sudut[i]*Math.PI/180));
            int posy=(int)(getY()+r*Math.sin(sudut[i]*Math.PI/180));
            latar.addObject(new Tulisan(kata[i]),posx,posy);
        }
        setValue();
    }    
}
