import greenfoot.*; 
import java.awt.Color;
/**
 * @author (Sugeng Rianto and Ubaidillah) 
 * @version (1.0)
 */
public class Latar extends World
{
    public int n=0;
    private Layar layar=null;
    private BtnPutar[] button=null;
    private Scroll scroll=new Scroll();
    
    public Latar()
    {    
        super(600, 400, 1,false); 
        GreenfootImage image=getBackground();
        image.setColor(Color.BLACK);
        image.fill();
        setBackground(image);
        
        layar=new Layar();
        addObject(layar,155,82);
        
        addObject(new Tulisan("s"),334,178);
        addObject(new Tulisan("ms "),334,31);
        addObject(new Tulisan("us"),515,31);
        addObject(new Tulisan("V"),357,372);
        addObject(new Tulisan("mV "),512,372);
        addObject(new Tulisan("Amplitude"),151,207);
        addObject(new Tulisan("Frequency = x + 10^y"),151,377);
        
        button=new BtnPutar[4];
        
        button[0]=new BtnPutar();
        button[0].step=15;
        button[0].awal=135;        
        button[0].max=300;
        button[0].min=45;
        button[0].ID=0;
        addObject(button[0],432,114);
        
        button[1]=new BtnPutar();
        button[1].step=30;
        button[1].awal=105;
        button[1].ID=1;
        button[1].max=330;
        addObject(button[1],432,290);      
        
        button[2]=new BtnGen();
        button[2].ID=2;
        button[2].awal=115;
        button[2].min=15;
        button[2].max=300;
        addObject(button[2],76,295);       
        
        button[3]=new BtnGen();
        button[3].ID=3;
        button[3].awal=150;
        button[3].step=30;
        button[3].min=60;
        button[3].max=210;
        addObject(button[3],232,295);  
        
        addObject(scroll,16,186);
        addObject(new Terapan(),0,0);
    }
    
    public void act()
    {        
        int batas=2;
        if(n<batas){
            layar.drawSignal(0.5*scroll.Value,button[2].Value*button[3].Value,button[0].Value,button[1].Value);
        }else if(n>batas)n=batas;
        n++;
    }
}
