import greenfoot.*; 
import java.awt.Color;
/**
 * @author (Sugeng Rianto and Ubaidillah) 
 * @version (1.0)
 */
public class Terapan extends Actor
{
    public int w=500,h=300;
    private boolean awal=true,moved=false;
    private int x=0,y=0,dx=5,target=0;
    private boolean hide=true,clicked=false;
    private int klik=0,count=0,lifetime=50;
    private GreenfootImage image=new GreenfootImage(w,h);
    private Latar latar;
    
    public void Cetak()
    {
        GreenfootImage isi=new GreenfootImage("implementation.png");
        image=new GreenfootImage(isi.getWidth()+30,isi.getHeight()+10);        
        image.setColor(new Color(0,186,255));
        image.drawImage(isi,15,5);
        image.drawRect(0,0,image.getWidth()-1,image.getHeight()-1);
        int[] xox=new int[]{0,10,0};
        int[] xoy=new int[]{2,(int)(0.5*image.getHeight()),(int)(image.getHeight())};
        image.drawPolygon(xox,xoy,3);
        setImage(image);
    }
    
    public void makeFront()
    {
        int posx=getX();
        int posy=getY();
        latar.removeObject(this);
        latar.addObject(this,posx,posy);
    }
    
    public void addedToWorld(World Latar)
    {
        latar=(Latar)getWorld();
        Cetak();
        if(awal){
            awal=false;
            setLocation((int)(latar.getWidth()+0.5*image.getWidth()-12),(int)(0.5*latar.getHeight()));
            x=getX();y=getY();
        }
    }
    
    private void move()
    {        
        setLocation(getX()+dx,getY());
        if(dx<0 && target>getX()){
            moved=false;
        }
        
        if(dx>0 && target<getX()){
            moved=false;
        }
    }
    
    private void doClick()
    {
        moved=true;
        if(getX()<x){
            dx=10;
            target=x-dx;
        }else{         
            dx=-10;
            target=(int)(latar.getWidth()-160)-dx;   
        }
        move();
    }
    
    public void act() 
    {
        if(clicked)count++;
        if(moved)move();
        if(count>=lifetime){
            count=0;
            klik=0;
            clicked=false;
        }
        
        if(Greenfoot.mouseClicked(this)){
            if(!clicked)clicked=true;
            klik++;
            if(klik==2){
                if(!moved)doClick();
                klik=0;
            }
        }
    }    
}
